#!/bin/bash

tag=$1
rt="/mnt/data/projects/safe_release"
cd $rt

bin_te=bin/PitchExt

spt=$rt/list
# gth file list
gthscp=$spt/gth.lst

# wave file list
wavscp=$spt/wav_seed.lst

# cfg files
fea_cfg=$rt/config/fea_cfg
pch_cfg=$rt/config/pch_cfg
pch_cfg_temp=$rt/config/pch_cfg_temp

for tp in "w" "b"
do
	for snr in `echo 40 20 10 5 0 -5`
	do
            if [ $tp = "b" ] && [ $snr = "40" ]
            then
                continue
            fi
            repl=${tp}_${snr}
            echo $repl
            wavnow=$spt/wav_${repl}.scp
            detnow=$spt/det_${repl}.scp
            w2gnow=$spt/w2g_${repl}.scp
            sed -e "s/seed/${repl}/" -e "s/wav/mstk/" $wavscp >$detnow
            sed -e "s/seed/${repl}/" $wavscp >$wavnow
            paste $wavnow $gthscp >$w2gnow

            # Obtain the F0 candidates for each file
	    for sc in `echo 0.08`
	    do
                # extract cands
                echo "scaling_factor:$sc"
                while read line
                do
                    wav=`echo $line | cut -d ' ' -f1`
                    gth=`echo $line | cut -d ' ' -f2`
                    det_cand=`echo $wav | sed "s/wav/cand/"`
                    det_mstk=`echo $wav | sed "s/wav/mstk/"`
                    sed -e "s/<COST_SCALE_FAC> 0.08/<COST_SCALE_FAC> ${sc}/" $pch_cfg >$pch_cfg_temp
                    # stage 2 dynamic programming, here only using the voicing information in the $gth files
                    $bin_te -s 2 -c1 $fea_cfg -c2 $pch_cfg_temp -i $det_cand -o $det_mstk -f $gth -m $pdf
                done < $w2gnow
                perl perl/CalPtkErrors.pl $detnow $gthscp 0
	    done
        done
done
