#!/bin/bash
# testing, extract F0 candidates

rt="/mnt/data/projects/safe_release"
cd $rt

# mstk
bin_te=bin/PitchExt

spt=$rt/list
# gth file list
gthscp=$spt/gth.lst

# wave file list
wavscp=$spt/wav_seed.lst

# cfg files
fea_cfg=$rt/config/fea_cfg
# all bands
pch_cfg=$rt/config/pch_cfg

# model
mdir=$rt/model/estimation

for tp in "w" "b"
do
	for snr in `echo 40 20 10 5 0 -5`
	do
            if [ $tp = "b" ] && [ $snr = "40" ]
            then
                continue
            fi
            repl=${tp}_${snr}
            echo $repl
            wavnow=$spt/wav_${repl}.scp
            w2gnow=$spt/w2g_${repl}.scp
            sed -e "s/seed/${repl}/" $wavscp >$wavnow
            paste $wavnow $gthscp >$w2gnow
            pdf=${mdir}/k_${tp}_${snr}.pdf
            zmpdf=${mdir}/k_${tp}_${snr}.zm.pdf

            # extract candidates
            while read line
            do
                wav=`echo $line | cut -d ' ' -f1`
                gth=`echo $line | cut -d ' ' -f2`
                det_cand=`echo $wav | sed "s/wav/cand/"`
                det_zmcand=`echo $wav | sed "s/wav/zmcand/"`
                det_mstk=`echo $wav | sed "s/wav/mstk/"`
                # stage 1:  obtain F0 candidates, nonzero or zero mean residual models
                $bin_te -c1 $fea_cfg -c2 $pch_cfg -s 1 -i $wav -o $det_cand -f $gth -m $pdf
                # $bin_te -c1 $fea_cfg -c2 $pch_cfg -s 1 -i $wav -o $det_zmcand -f $gth -m $zmpdf
            done < $w2gnow
        done
done


