#!/bin/bash

rt=$SAFEDIR
cd $rt

bin_te=bin/PitchExt
spt=$rt/list
# gth file list
gthscp=$rt/data/keele/gth.lst
# wave file list
wavscp=$spt/k_wav.scp

# cfg files
fea_cfg=$rt/config/fea_cfg
# all bands
pch_cfg=$rt/config/pch_cfg
pch_cfg_temp=$rt/config/pch_cfg_temp

# model
mdir=$rt/model/estimation

for tp in "w" "b"
do
	for snr in `echo 0`
	do
            if [ $tp = "b" ] && [ $snr = "40" ]
            then
                continue
            fi
            repl=${tp}_${snr}
            echo $repl
            wavnow=$spt/wav_${repl}.scp
            detnow=$spt/det_${repl}.scp
            w2gnow=$spt/w2g_${repl}.scp
            sed -e "s/test/test_${repl}/" $wavscp >$wavnow
	    sed -e "s/wav/mstk/" $wavnow >$detnow
            paste $wavnow $gthscp >$w2gnow
            pdf=${mdir}/k_${tp}_${snr}.pdf
            zmpdf=${mdir}/k_${tp}_${snr}.zm.pdf

            # extract candidates
            while read line
            do
                wav=`echo $line | cut -d ' ' -f1`
                gth=`echo $line | cut -d ' ' -f2`
                det_cand=`echo $wav | sed "s/wav/cand/"`
                det_zmcand=`echo $wav | sed "s/wav/zmcand/"`
                det_mstk=`echo $wav | sed "s/wav/mstk/"`
                # stage 1:  obtain F0 candidates, nonzero or zero mean residual models
                $bin_te -c1 $fea_cfg -c2 $pch_cfg -s 1 -i $wav -o $det_cand -f $gth -m $pdf
                # $bin_te -c1 $fea_cfg -c2 $pch_cfg -s 1 -i $wav -o $det_zmcand -f $gth -m $zmpdf
            done < $w2gnow

            # Obtain the F0 candidates for each file
	    for sc in `echo 0.08`
	    do
                # extract cands
                echo "dp_ratio:$sc"
                while read line
                do
                    wav=`echo $line | cut -d ' ' -f1`
                    gth=`echo $line | cut -d ' ' -f2`
                    det_cand=`echo $wav | sed "s/wav/cand/"`
                    det_mstk=`echo $wav | sed "s/wav/mstk/"`
                    sed -e "s/<DP_RATIO> 0.08/<DP_RATIO> ${sc}/" $pch_cfg >$pch_cfg_temp
                    # stage 2 dynamic programming, here only using the voicing information in the $gth files
                    $bin_te -s 2 -c1 $fea_cfg -c2 $pch_cfg_temp -i $det_cand -o $det_mstk -f $gth -m $pdf
                done < $w2gnow
                perl perl/CalPtkErrors.pl $detnow $gthscp 0
	    done
        done
done

