#!/bin/bash

ntype="w"
nlevel="40"
zflag="0"

# input: the wave file
wavfile=$1
# input: the voicing status file
uvsfile=$2
# input: the F0 contour file
detfile=$3
# input: noise type, w (white) or b (babble)
ntype=$4
# input: SNR level in dB, 40 (clean), 20, 10, 5, 0, or -5.
nlevel=$5
# input: the flag of using zero mean models, 1 -- use, 0 -- do not use.
zflag=$6

rt=$SAFEDIR
bin_te=$rt/bin/PitchExt

candfile=$wavfile.cand

# cfg files
fea_cfg=$rt/config/fea_cfg
# all bands
pch_cfg=$rt/config/pch_cfg
pch_cfg_temp=$rt/config/pch_cfg_temp

# model file
if [ zflag == "1" ]
then
	modfile=$rt/model/estimation/k_${ntype}_${nlevel}.zm.pdf
else
	modfile=$rt/model/estimation/k_${ntype}_${nlevel}.pdf
fi


$bin_te -s 1 -c1 $fea_cfg -c2 $pch_cfg -i $wavfile -o $candfile -f $uvsfile -m $modfile
$bin_te -s 2 -c1 $fea_cfg -c2 $pch_cfg -i $candfile -o $detfile -f $uvsfile -m $modfile

