#!/bin/bash
# traing F0 estimation models

rt=$SAFEDIR
cd $rt

# mstk
bin_tr=bin/PitchTrain

spt=$rt/list
# gth file list
gthscp=$rt/data/keele/gth.lst
# wave file list
wavscp=$spt/k_wav.scp

# cfg files
fea_cfg=$rt/config/fea_cfg
# all bands
pch_cfg=$rt/config/pch_cfg

# model
mdir=$rt/model/estimation
mkdir -p $mdir

for tp in "w" "b"
do
	for snr in `echo 0`
	do
            if [ $tp = "b" ] && [ $snr = "40" ]
            then
                continue
            fi
            repl=${tp}_${snr}
            echo $repl
            wavnow=$spt/wav_${repl}.scp
            w2gnow=$spt/w2g_${repl}.scp
            sed -e "s/test/test_${repl}/" $wavscp >$wavnow
            paste $wavnow $gthscp >$w2gnow
            mod=${mdir}/k_${tp}_${snr}.pdf
            
            # accumulate statistics and 
            $bin_tr -s 1 -c1 $fea_cfg -c2 $pch_cfg -l $w2gnow -m $mod
	    # train F0 estimation models (will generate *.pdf and *.zm.pdf)
	    $bin_tr -s 2 -c1 $fea_cfg -c2 $pch_cfg -l $w2gnow -m $mod
	done
done
