#!/usr/bin/perl -w

# use FaNT package to add noise

use File::Path;

if (@ARGV != 7) {
    die "Usage: AddNoise.pl <wavsuffix> <wavlst> <dstdir> <noisepath> <noisetype> <snr> <seed>\n";
}

$wvsf = shift @ARGV;
$wavlst = shift @ARGV;      # clean wave list
$dstdir = shift @ARGV;      # destination dir to write wave in
$nfile  = shift @ARGV;      # noise file
$ntype  = shift @ARGV;      # noise type
$snr    = shift @ARGV;      # SNR level (dB)
$seed   = shift @ARGV;      # seed: train - 0 test - 1

# noise wav to raw
$nfraw = $nfile;
$nfraw =~ s/$wvsf/raw/i;
$cmd = "sox $nfile $nfraw";
system $cmd;

# create $dstdir if it does not exist
mkpath $dstdir;

open LST, $wavlst;
@wavarr = <LST>;
close LST;

$wavlst =~ /(.*)\./;
$prepath = $1;
$rawlst = $prepath."\_raw.txt";
$newlst = $prepath."\_$ntype\_$snr.txt";
$addlst = $prepath."\_$ntype\_$snr\_raw.txt";
$idxlst = $prepath."\_$ntype\_$snr.idx";

open RAW, ">$rawlst";
open ADD, ">$addlst";
open NEW, ">$newlst";

# prepare noisy wav list
foreach $wav (@wavarr) {
    #/mnt/d/Corpus/TIMIT/timit/train/dr1/fcjf0/sa1.wv1
    chomp $wav;
    $raw = $wav;
    $raw =~ s/$wvsf/raw/i;
    #/mnt/d/Corpus/TIMIT/timit/train/dr1/fcjf0/sa1.raw
    print RAW "$raw\n";
    if (not -e $raw) {
        $cmd = "sox $wav $raw";
        system $cmd;
    }

    #../train/dr1/fcjf0/sa1.$wvsf => /$dst_dir/train_white_20db/dr1/fcjf0/sa1.$wvsf
    $raw =~ s/(.*)\/(train|test)/$dstdir\/$2/;
    $raw =~ s/(train|test)/$1\_$ntype\_$snr/;
    print ADD "$raw\n";

    # mkdir for noisy data
    $raw =~/(.*\/)/;
    mkpath $1;
    $raw =~ s/raw/$wvsf/;
    #/dst_dir/train_white_20db/dr1/fcjf0/sa1.$wvsf
    print NEW "$raw\n";

}
close RAW;
close ADD;
close NEW;

print "dir and raw data are prepared.\n";

# create list
if (-e $idxlst) {
    unlink($idxlst);
}
$cmd = "bin/create_list -i $rawlst -o $idxlst -n $nfile -r $seed"; # seed = 0
system $cmd;
print "Index list for adding noise created.\n";


# add noise ( keele - 16kHz, using -u -m snr_8khz)
$cmd = "bin/fant -i $rawlst -o $addlst -n $nfile -u -m snr_8khz -s $snr -a $idxlst"; #
system $cmd;
print "Noise added.\n";


# raw w/ noise -> wav w/ noise
open LST, $addlst;
@rawarr = <LST>;
close LST;
foreach $raw (@rawarr) {
    chomp $raw;
    $wav = $raw;
    $wv1 = $raw;
    $wav =~ s/raw/wav/;
    $cmd = "sox -r 16000 -s -2 -c 1 $raw $wav";
    system $cmd;
    if ($wvsf ne 'wav') {
        $wv1 =~ s/raw/$wvsf/;
        system "mv $wav $wv1";
    }
}

print "Add noise finished. \n";
